#!/usr/bin/python

#written by Charles Bigcat, mainly for Linux users :3

import sys, pygame
from string import split

world = [['_','_','_','_','_','_','_','_'],['_','_','_','_','_','_','_','_'],['_','_','_','_','_','_','_','_'],['_','_','_','_','_','_','_','_'],['_','_','_','_','_','_','_','_'],['_','_','_','_','_','_','_','_'],['_','_','_','_','_','_','_','_'],['_','_','_','_','_','_','_','_']]


w0 = ['_','_','_','_','_','_','_','_']
w1 = ['_','_','_','_','_','_','_','_']
w2 = ['_','_','_','_','_','_','_','_']
w3 = ['_','_','_','_','_','_','_','_']
w4 = ['_','_','_','_','_','_','_','_']
w5 = ['_','_','_','_','_','_','_','_']
w6 = ['_','_','_','_','_','_','_','_']
w7 = ['_','_','_','_','_','_','_','_']

shape = ['T','C','D']
size = ['S','M','L']

def printWorld(filename, graphical):
	file = open(filename, 'r')
	content = file.readlines()
	content = split(content[0], '\r')
	file.close()

	print content
	print ""
	print "***"
	print "Snakie's World interpreter for Tarski's World v", content[0]
	print "***"
	print ""

	maxItems = int(content[3])

	count = 3
	currentItem = 1
	while currentItem<=maxItems:
		count = count + 1
		temp = content[count]
		t1 = int(temp[0])-1
		t2 = int(temp[2])-1
		visual = shape[t1] + size[t2]
		
		count = count + 1
		temp = content[count]
		x = int(temp[0])
		y = int(temp[2])

		count = count + 1
		temp = content[count]
		try:
			visual = visual + ('(%s)' % (temp[1:]))
		except:
			visual = visual + '()'

		world[x][y] = visual

		currentItem = currentItem + 1

	if (graphical == 'n'):
		text_output()
	else:
		x_output()

def text_output():
	y = 7
	while y>=0:
		print '%5s %5s %5s %5s %5s %5s %5s %5s' % (world[0][y],world[1][y],world[2][y],world[3][y],world[4][y],world[5][y],world[6][y],world[7][y])
		y = y - 1

def x_output():
	pygame.init()

	size = width, height = 400,400
	black = 0,0,0

	font = pygame.font.Font(None, 30)

	screen = pygame.display.set_mode(size)
	screen.fill(black)

	scube = pygame.image.load("scube.png")
	scuberect = scube.get_rect()
	mcube = pygame.image.load("mcube.png")
	mcuberect = mcube.get_rect()
	lcube = pygame.image.load("lcube.png")
	lcuberect = lcube.get_rect()
	stet = pygame.image.load("stet.png")
	stetrect = stet.get_rect()
	mtet = pygame.image.load("mtet.png")
	mtetrect = mtet.get_rect()
	ltet = pygame.image.load("ltet.png")
	ltetrect = ltet.get_rect()
	sdodec = pygame.image.load("sdodec.png")
	sdodecrect = sdodec.get_rect()
	mdodec = pygame.image.load("mdodec.png")
	mdodecrect = mdodec.get_rect()
	ldodec = pygame.image.load("ldodec.png")
	ldodecrect = ldodec.get_rect()
	darkness = pygame.image.load("darkness.png")
	darknessrect = darkness.get_rect()

	x = 0
	y = 7
	while y>=0:
		while x<8:
			object = world[x][y]
			if (object[0]=='C'):
				if (object[1]=='S'):
					scuberect.topleft = x*50,350-y*50
					screen.blit(scube,scuberect)
				if (object[1]=='M'):
					mcuberect.topleft = x*50,350-y*50
					screen.blit(scube,mcuberect)
				if (object[1]=='L'):
					lcuberect.topleft = x*50,350-y*50
					screen.blit(scube,lcuberect)
			elif (object[0]=='T'):
				if (object[1]=='S'):
					stetrect.topleft = x*50,350-y*50
					screen.blit(stet,stetrect)
				if (object[1]=='M'):
					mtetrect.topleft = x*50,350-y*50
					screen.blit(mtet,mtetrect)
				if (object[1]=='L'):
					ltetrect.topleft = x*50,350-y*50
					screen.blit(ltet,ltetrect)
			elif (object[0]=='D'):
				if (object[1]=='S'):
					sdodecrect.topleft = x*50,350-y*50
					screen.blit(sdodec,sdodecrect)
				if (object[1]=='M'):
					mdodecrect.topleft = x*50,350-y*50
					screen.blit(mdodec,mdodecrect)
				if (object[1]=='L'):
					ldodecrect.topleft = x*50,350-y*50
					screen.blit(ldodec,ldodecrect)
			else:
				darknessrect.topleft = x*50,350-y*50
				screen.blit(darkness,darknessrect)
			if len(object)>4:
				names = len(object)-4
				text = font.render(object[3:(3+names)], 1, (200, 200, 200))
				textrect = text.get_rect()
				textrect.topleft = x*50+18, 362-(y*50)
				screen.blit(text,textrect)
			x = x + 1
		x = 0
		y = y - 1

	pygame.display.flip()

	while 1:
		for event in pygame.event.get():
			if (event.type==pygame.QUIT):
				sys.exit()

def frontend():
	print "Enter the filename + extension (for example: Game World.wld)"
	filename = raw_input("(has to be in the same directory (default)): ")
	graphical = raw_input("Would you like a graphical display? (pygame required!): ")
	printWorld(filename, graphical)
	print "\n"
	raw_input()

def test(filename):
	file = open(filename, 'r')
	content = file.readlines()
	content = split(content[0], '\r')
	print content

try:
	printWorld(filename[1:], 'y')
except:
	frontend()
